// Test du scheduler : SCHED_FIFO et SCHED_OTHER
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sched.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/wait.h>




int main(int argc, char*argv[])
{
	int i,n=10;// Pour le SCHED_OTHER: n=0 on influe pas. n=2 (par exemple) on se dégrade
	struct sched_param sp;
	int policy;

	policy = sched_getscheduler(0);
	if (  policy == SCHED_FIFO ) printf("(%d)SCHED_FIFO\n", getpid());
	if (  policy == SCHED_OTHER ) printf("(%d)SCHED_OTHER\n", getpid());
	if (  policy == SCHED_RR ) printf("(%d)SCHED_RR\n", getpid());

	sched_getparam(0, &sp); // remplissage de la structure 
	sp.sched_priority = 20;// 0 pour un SCHD_OTHER, de 1 à 99 pour les autres
	if ( sched_setscheduler(0, SCHED_RR, &sp) < 0) perror("SetScheduler"); // application du réglage
	
	policy = sched_getscheduler(0);
	if (  policy == SCHED_FIFO ) printf("(%d)SCHED_FIFO\n", getpid());
	if (  policy == SCHED_OTHER ) printf("(%d)SCHED_OTHER\n", getpid());
	if (  policy == SCHED_RR ) printf("(%d)SCHED_RR\n", getpid());
}
